% Tested in Matlab R2021a
% Adapted from: De Clercq, G. K., Dietrich, A., Nez Velasco, P., De Winter, J. C F., & Happee, R. (2019). External human-machine interfaces on automated vehicles: Effects on pedestrian crossing decisions. Human Factors, 61, 13531370. https://doi.org/10.1177/0018720819836343
% Joost de Winter, May 2022
%% Yielding vehicles
clear all
load('results_yielding.mat');
load('x_yielding.mat');
f=figure;hold on
titles = {'50 m, Front brake', '50 m, Knightrider', '50 m, Smiley', '50 m, Text','20 m, Front brake', '20 m, Knightrider', '20 m, Smiley', '20 m, Text','35 m, Front brake', '35 m, Knightrider', '35 m, Smiley', '35 m, Text'};

% 1	BMW_Baseline1
% 2	BMW_Baseline2
% 3	BMW_Baseline3
% 4	BMW_50_m_frontal
% 5	BMW_50_m_Knightrider
% 6	BMW_50_m_smiley
% 7	BMW_50_m_text
% 8	BMW_20_m_frontal
% 9	BMW_20_m_Knightrider
% 10	BMW_20_m_smiley
% 11	BMW_20_m_text
% 12	BMW_35_m_frontal
% 13	BMW_35_m_Knightrider
% 14	BMW_35_m_smiley
% 15	BMW_35_m_text
% 16	Smart_Baseline1
% 17	Smart_Baseline2
% 18	Smart_Baseline3
% 19	Smart_50_m_frontal
% 20	Smart_50_m_Knightrider
% 21	Smart_50_m_smiley
% 22	Smart_50_m_text
% 23	Smart_20_m_frontal
% 24	Smart_20_m_Knightrider
% 25	Smart_20_m_smiley
% 26	Smart_20_m_text
% 27	Smart_35_m_frontal
% 28	Smart_35_m_Knightrider
% 29	Smart_35_m_smiley
% 30	Smart_35_m_text
% 31	Ford_Baseline1
% 32	Ford_Baseline2
% 33	Ford_Baseline3
% 34	Ford_50_m_frontal
% 35	Ford_50_m_Knightrider
% 36	Ford_50_m_smiley
% 37	Ford_50_m_text
% 38	Ford_20_m_frontal
% 39	Ford_20_m_Knightrider
% 40	Ford_20_m_smiley
% 41	Ford_20_m_text
% 42	Ford_35_m_frontal
% 43	Ford_35_m_Knightrider
% 44	Ford_35_m_smiley
% 45	Ford_35_m_text
titles = {'50 m', '50 m', '50 m', '50 m','35 m', '35 m', '35 m', '35 m','20 m', '20 m', '20 m', '20 m',};

meanfeelsafe=NaN(45,1501);
selection = [2:45:1261 3:45:1261 4:45:1261 17:45:1261 18:45:1261 19:45:1261 32:45:1261 33:45:1261 34:45:1261]; % select 9 repetitions of baseline
meanfeelsafe(1,:) = sum(results(selection,:),1)/size(results(selection,:),1);
SS=NaN(4,336);
SS(1,1:length(selection))=selection;
V=[4 5 6 7  12 13 14 15  8 9 10 11];count=0;
for i = 1:4:12 % Baseline, Front brake light early, Knight rider early, ...
    count=count+1;
        selection = [V(i)+1:45:1261 V(i)+16:45:1261 V(i)+31:45:1261 V(i+1)+1:45:1261 V(i+1)+16:45:1261 V(i+1)+31:45:1261 V(i+2)+1:45:1261 V(i+2)+16:45:1261 V(i+2)+31:45:1261 V(i+3)+1:45:1261 V(i+3)+16:45:1261 V(i+3)+31:45:1261]; % select 3 repetitions of particular eHMI x timing combination
    
        SS(1+ceil((i)/4),1:length(selection))=selection;

        meanfeelsafe(V(i),:) = sum(results(selection,:),1)/size(results(selection,:),1);
    subplot(1,3,count);hold on
    h = area(x_filtered,meanfeelsafe(V(i),:)*100);h(1).FaceColor = [98 183 252]/255;
    plot(x_filtered,meanfeelsafe(1,:)*100,'k--','LineWidth',2) % Baseline
    if ismember(V(i),4:7)
        plot([50 50],[0 100],':','Color','b','LineWidth',4) % 50 m line
    elseif ismember(V(i),8:11)
        plot([20 20],[0 100],':','Color','b','LineWidth',4) % 20 m line
    elseif ismember(V(i),12:15)
        plot([35 35],[0 100],':','Color','b','LineWidth',4) % 35 m line
    end
    axis([0 50 0 100])
    set(gca,'xdir', 'reverse' ,'xtick',0:10:52,'TickDir','out','Layer', 'top')
    box on
    title(titles{i},'fontsize',24);
end
h=findobj('FontName','Helvetica'); set(h,'FontSize',24,'Fontname','Arial')
set(gca, 'LooseInset', [0.01 0.01 0.01 0.01]);
text(gca,'String','Distance (m)','Position',[118 -12 0],'rotation',0,'FontSize',26);
text(gca,'String','Percentage of participants feeling safe to cross','Position',[215 3 0],'rotation',90,'FontSize',26);
f.WindowState = 'maximized';
set(gcf, 'PaperUnits', 'inches','paperpositionmode','auto');
set(gcf,'WindowState','maximized');print(gcf,'Figure2.png','-dpng','-r300');